type Credit = int;
type ReplicaID;
var localCredit: [ReplicaID]Credit;
var globalCredit: Credit;
procedure releaseCredit(replica: ReplicaID, k: Credit)
modifies globalCredit;
modifies localCredit;
requires (k > 0 && localCredit[replica] >= k);
ensures ((forall r:ReplicaID :: (r == replica ==> localCredit[r] == old(localCredit)[r] - k) && (r != replica ==> localCredit[r] == old(localCredit)[r])) && globalCredit == old(globalCredit) + k);
{
assume(false);
}
const unique _replica0:ReplicaID;
const unique _k0:Credit;
procedure _main0()
modifies globalCredit;
modifies localCredit;
ensures ((forall r:ReplicaID :: localCredit[r] >= 0) && (globalCredit >= 0));
{
assume((forall r:ReplicaID :: localCredit[r] >= 0) && (globalCredit >= 0));
assume(_k0 > 0 && localCredit[_replica0] >= _k0);
call releaseCredit (_replica0, _k0);
}
