type Credit = int;
type ReplicaID;
var localCredit: [ReplicaID]Credit;
var globalCredit: Credit;
var _localCredit0: [ReplicaID]Credit;
var _globalCredit0: Credit;
var _localCredit1: [ReplicaID]Credit;
var _globalCredit1: Credit;
procedure _decrement0(replica: ReplicaID, k: Credit)
modifies localCredit;
requires (k > 0 && localCredit[replica] >= k);
ensures (forall r:ReplicaID :: (r == replica ==> localCredit[r] == old(localCredit)[r] - k) && (r != replica ==> localCredit[r] == old(localCredit)[r]));
{
assume(false);
}
procedure _decrement1(replica: ReplicaID, k: Credit)
modifies localCredit;
requires (k > 0 && localCredit[replica] >= k);
ensures (forall r:ReplicaID :: (r == replica ==> localCredit[r] == old(localCredit)[r] - k) && (r != replica ==> localCredit[r] == old(localCredit)[r]));
{
assume(false);
}
const _replica0:ReplicaID;
const _k0:Credit;
const _replica1:ReplicaID;
const _k1:Credit;
procedure _main0()
modifies localCredit;
modifies globalCredit;
modifies _localCredit0;
modifies _globalCredit0;
modifies _localCredit1;
modifies _globalCredit1;
{
assume(_replica0 != _replica1);
assume((forall r:ReplicaID :: localCredit[r] >= 0) && (globalCredit >= 0));
assume(_k0 > 0 && localCredit[_replica0] >= _k0);
assume(_k1 > 0 && localCredit[_replica1] >= _k1);
_localCredit0 := localCredit;
_globalCredit0 := globalCredit;
call _decrement0 (_replica0, _k0);
call _decrement1 (_replica1, _k1);
_localCredit1 := localCredit;
_globalCredit1 := globalCredit;
localCredit := _localCredit0;
globalCredit := _globalCredit0;
call _decrement1 (_replica1, _k1);
call _decrement0 (_replica0, _k0);
assert(forall r:ReplicaID :: localCredit[r] == _localCredit1[r]);
assert(globalCredit == _globalCredit1);
}
