type Credit = int;
type ReplicaID;
var localCredit: [ReplicaID]Credit;
var globalCredit: Credit;
procedure decrement(replica: ReplicaID, k: Credit)
modifies localCredit;
requires (k > 0 && localCredit[replica] >= k);
ensures (forall r:ReplicaID :: (r == replica ==> localCredit[r] == old(localCredit)[r] - k) && (r != replica ==> localCredit[r] == old(localCredit)[r]));
{
assume(false);
}
