type Credit = int;
type ReplicaID;
var localCredit: [ReplicaID]Credit;
var globalCredit: Credit;
procedure decrement(replica: ReplicaID, k: Credit)
modifies localCredit;
requires (k > 0 && localCredit[replica] >= k);
ensures (forall r:ReplicaID :: (r == replica ==> localCredit[r] == old(localCredit)[r] - k) && (r != replica ==> localCredit[r] == old(localCredit)[r]));
{
assume(false);
}
const unique _replica0:ReplicaID;
const unique _k0:Credit;
procedure _main0()
modifies localCredit;
{
assume((forall r:ReplicaID :: localCredit[r] >= 0) && (globalCredit >= 0));
assume(_k0 > 0 && localCredit[_replica0] >= _k0);
call decrement (_replica0, _k0);
assert(false);
}
