type Credit = int;
type ReplicaID;
var localCredit: [ReplicaID]Credit;
var globalCredit: Credit;
procedure releaseCredit(replica: ReplicaID, k: Credit)
modifies globalCredit;
modifies localCredit;
requires (k > 0 && localCredit[replica] >= k);
ensures ((forall r:ReplicaID :: (r == replica ==> localCredit[r] == old(localCredit)[r] - k) && (r != replica ==> localCredit[r] == old(localCredit)[r])) && globalCredit == old(globalCredit) + k);
{
assume(false);
}
