type Credit = int;
type ReplicaID;
var localCredit: [ReplicaID]Credit;
var globalCredit: Credit;
var _localCredit0: [ReplicaID]Credit;
var _globalCredit0: Credit;
var _localCredit1: [ReplicaID]Credit;
var _globalCredit1: Credit;
procedure increment(replica: ReplicaID, k: Credit)
modifies localCredit;
requires (k > 0);
ensures (forall r:ReplicaID :: (r == replica ==> localCredit[r] == old(localCredit)[r] + k) && (r != replica ==> localCredit[r] == old(localCredit)[r]));
{
assume(false);
}
const _k0:Credit;
const _replica0:ReplicaID;
procedure _main0()
modifies localCredit;
modifies globalCredit;
modifies _localCredit0;
modifies _globalCredit0;
modifies _localCredit1;
modifies _globalCredit1;
{
assume((forall r:ReplicaID :: localCredit[r] >= 0) && (globalCredit >= 0));
assume(_k0 > 0);
_localCredit0 := localCredit;
_globalCredit0 := globalCredit;
call increment (_replica0, _k0);
_localCredit1 := localCredit;
_globalCredit1 := globalCredit;
localCredit := _localCredit0;
globalCredit := _globalCredit0;
call increment (_replica0, _k0);
assert(forall r:ReplicaID :: localCredit[r] == _localCredit1[r]);
assert(globalCredit == _globalCredit1);
}
