type Credit = int;
type ReplicaID;
var localCredit: [ReplicaID]Credit;
var globalCredit: Credit;
procedure increment(replica: ReplicaID, k: Credit)
modifies localCredit;
requires (k > 0);
ensures (forall r:ReplicaID :: (r == replica ==> localCredit[r] == old(localCredit)[r] + k) && (r != replica ==> localCredit[r] == old(localCredit)[r]));
{
assume(false);
}
const unique _k0:Credit;
const unique _replica0:ReplicaID;
procedure _main0()
modifies localCredit;
ensures ((forall r:ReplicaID :: localCredit[r] >= 0) && (globalCredit >= 0));
{
assume((forall r:ReplicaID :: localCredit[r] >= 0) && (globalCredit >= 0));
assume(_k0 > 0);
call increment (_replica0, _k0);
}
