type Credit = int;
type ReplicaID;
var localCredit: [ReplicaID]Credit;
var globalCredit: Credit;
procedure acquireCredit(replica: ReplicaID, k: Credit)
modifies globalCredit;
modifies localCredit;
requires (k > 0 && globalCredit >= k);
ensures ((forall r:ReplicaID :: (r == replica ==> localCredit[r] == old(localCredit)[r] + k) && (r != replica ==> localCredit[r] == old(localCredit)[r])) && globalCredit == old(globalCredit) - k);
{
assume(false);
}
const unique _k0:Credit;
const unique _replica0:ReplicaID;
procedure _main0()
modifies globalCredit;
modifies localCredit;
{
assume((forall r:ReplicaID :: localCredit[r] >= 0) && (globalCredit >= 0));
assume(_k0 > 0 && globalCredit >= _k0);
call acquireCredit (_replica0, _k0);
assert(false);
}
